# codegenmain.py - Perform Code Generation with Cheetah

# Copyright (c) 2007-2008, Jason Breti (http://breti.org/codegen)
# All rights reserved.
# This code is released under the BSD License, as specified in the
# license.txt file.

from SM_Events_as import SM_Events_as
from SM_StateChart_as import SM_StateChart_as
from SM_State_generic_as import SM_State_generic_as

from loader import Loader
from generator import Generator

if __name__ == '__main__':
  
  loader = Loader()
  loader.load('./car_alarm.xml')

  generator = Generator()
  
  entireChartFiles = {'./src/SM_StateMachine/SM_Events.as':
                        SM_Events_as(),
                      './src/SM_StateMachine/SM_StateChart.as':
                        SM_StateChart_as() }
  
  for fileName in entireChartFiles:
    print 'Generating:', fileName
    generator.generateChart(loader.stateChartXML,
                            fileName,
                            entireChartFiles[fileName])
    
  
  stateFiles = {'.as':  SM_State_generic_as()
                }

  for extension in stateFiles:
    for stateNode in loader.stateChartXML.getchildren():
      if stateNode.tag == 'state' and \
         'id' in stateNode.attrib:
        fileName = './src/SM_StateMachine/SM_State_' + stateNode.attrib['id'] + extension
        print 'Generating:', fileName
        generator.generateState(loader.stateChartXML,
                                stateNode,
                                fileName,
                                stateFiles[extension])
    


