//-------------------------------------------------------------------------
//
// File Name: SM_StateChart.as
//
// This file is code generated.  Do not make any changes to this file, 
// except in the areas marked by "HandCraftedCode" markers.  All other 
// changes will be overwritten.
//
// Copyright (c) 2007-2009, Jason Breti (http://breti.org/codegen)
// All rights reserved.
// This code is released under the BSD License, as specified in the
// license.txt file.
//-------------------------------------------------------------------------

package SM_StateMachine
{

  //-----------------------------------------------------------------------
	// Import Libraries
  //-----------------------------------------------------------------------
  import flash.utils.Dictionary;

  //-----------------------------------------------------------------------
  public class SM_StateChart
  {
		//---------------------------------------------------------------------
		// Public Variables
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Public Constants
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Protected Variables and Constants
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Private Variables and Constants
		//---------------------------------------------------------------------
    // Holds all the states currently allocated.
    private var m_states:Dictionary;
    
    // Holds from each state to all other permitted states.
    private var m_transitions:Dictionary;

    // The current state for the state machine
    private var m_currentState:String;

		//---------------------------------------------------------------------
		// Public Methods
		//---------------------------------------------------------------------

		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: SM_StateChart (Constructor)
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    public function SM_StateChart ()
    {
      m_states = new Dictionary();
      
      m_transitions = new Dictionary();
      
      m_currentState = "";
    }

		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: initialize
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    public function initialize ():SM_State
    {
			var key:String;
			
      m_currentState = "Initial";
      
      // Construct all the necessary states

      // Add Initial State to the Map
      m_states["Initial"] = new SM_State_Initial();

      // Add Unarmed State to the Map
      m_states["Unarmed"] = new SM_State_Unarmed();

      // Add Armed State to the Map
      m_states["Armed"] = new SM_State_Armed();

      // Add WaitingToUnarm State to the Map
      m_states["WaitingToUnarm"] = new SM_State_WaitingToUnarm();

		  // Connect the states to each other through transitions
      // Add Transitions from the Initial state to all other permitted states
			var transitionStepsInitial:Dictionary = new Dictionary();
			transitionStepsInitial[SM_Events.BATTERYON] = "Unarmed";
			m_transitions["Initial"] = transitionStepsInitial;

      // Add Transitions from the Unarmed state to all other permitted states
			var transitionStepsUnarmed:Dictionary = new Dictionary();
			transitionStepsUnarmed[SM_Events.REMOTEARM] = "Armed";
			m_transitions["Unarmed"] = transitionStepsUnarmed;

      // Add Transitions from the Armed state to all other permitted states
			var transitionStepsArmed:Dictionary = new Dictionary();
			transitionStepsArmed[SM_Events.REMOTEUNARM] = "WaitingToUnarm";
			m_transitions["Armed"] = transitionStepsArmed;

      // Add Transitions from the WaitingToUnarm state to all other permitted states
			var transitionStepsWaitingToUnarm:Dictionary = new Dictionary();
			transitionStepsWaitingToUnarm[SM_Events.DOORSOPEN] = "Unarmed";
			transitionStepsWaitingToUnarm[SM_Events.UNARMTIMEREXPIRED] = "Armed";
			m_transitions["WaitingToUnarm"] = transitionStepsWaitingToUnarm;


			return m_states[m_currentState];

    }

		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		// Name: transitionState
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		public function transitionState (transitionEvent:String):Dictionary
		{
			var results:Dictionary = new Dictionary();
			results["transitionFound"] = false;
			results["nextState"] = 0;
			
			// Find the map containing the transitions for the current state
			if (m_currentState in m_transitions)
			{
		    // Inside those transitions find the next state, if a transition exists
		    // based on this event
				if (transitionEvent in m_transitions[m_currentState])
				{
					results["transitionFound"] = true;
					
					var nextState:String = m_transitions[m_currentState][transitionEvent];
	        m_currentState = nextState;
					
					results["nextState"] = m_states[nextState];
				}
			}

			return results;
		}

		//---------------------------------------------------------------------
		// Event Interface Methods
		//---------------------------------------------------------------------
    
		//---------------------------------------------------------------------
		// Protected Methods
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------
		// Private Methods
		//---------------------------------------------------------------------

		//---------------------------------------------------------------------

  }
}

//-------------------------------------------------------------------------
